Subject: Re: DWIM "git checkout frotz" to "git checkout -b frotz origin/frotz"

From: Clemens Buchacher <[email-masked]>
Date: Sun, 6 Jun 2010 19:32:33 +0200

On Sun, Jun 06, 2010 at 09:59:08AM -0700, Jacob Helwig wrote:
> On Sun, Jun 6, 2010 at 09:55, Clemens Buchacher <[email-masked]> wrote:
> >
> > I argue that people are more likely to be surprised and confused by
> > this feature rather than being accustomed to it already. I am also
> > waiting to hear from someone who actively uses this feature.
> >
> 
> I am someone that "actively" uses this feature.  I will often have
> repositories that I use on multiple machines, and will forget which
> remote branches I have local tracking branches for, on which machines.
>  I'll end up just doing `git checkout $random-branch`, thinking I'm on
> one of the machines where I've already setup the local branch, and
> find it quite handy that Git _does_ DWIM.

I see. But would it be so terrible to have to type "git checkout -t
origin/branch" instead?

Also, isn't this more like "foretell what I really want" rather
than "do what it means"? Who would guess that "git checkout
$branch" means "create $branch tracking <random-remote>/$branch"?

And this is exactly _why_ it can be marginally useful if the
foretelling is correct, but all the more confusing if it's not.